"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.
"
"{ Package: 'stx:libjava/experiments' }"

ClassReloadingTests subclass:#SingleClassReloadingTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Tests-ClassReloading'
!

!SingleClassReloadingTests class methodsFor:'documentation'!

copyright
"
 Copyright (c) 2010-2011 Jan Vrany, Jan Kurs & Marcel Hlopko,
                         SWING Research Group, Czech Technical University 
                         in Prague

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

"
!

history

    "Created: #testAddingMethod / 06-12-2012 / 21:52:02 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!SingleClassReloadingTests class methodsFor:'resources'!

resources
    ^ Array with: JavaFreshlyInitializedResource.

    "Created: / 06-12-2012 / 18:22:13 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!SingleClassReloadingTests methodsFor:'methods'!

testAddingMethod
    "changing class is a subclass of a class implementing callFoo. During the test callFoo method is overridden in changing class."
    
    | caller  changingObject |
    caller := self callerClass new.
    changingObject := self changingClassWithAddedCallFooMethod new.
    self assert: (caller callFoo: changingObject) == 1
        message: 'initial changing class should not override callFoo method'.
    JavaClassReloader reload: self changingClass
        with: self changingClassWithCallFooWithDifferentSignature.
    self assert: (caller callFoo: changingObject) == 2
        message: 'changing class should override callFoo method after reloading'.

    "Created: / 06-12-2012 / 21:52:02 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testChangingSignatureOfMethod
    "changing class is a subclass of a class implementing callFoo. During the test callFoo method is overridden in changing class."
    
    | caller  changingObject |
    caller := self callerClass new.
    changingObject := self changingClassWithAddedCallFooMethod new.
    self assert: (caller callFoo: changingObject) == 2
        message: 'initial changing class should not override callFoo method'.
    JavaClassReloader reload: self changingClass
        with: self changingClassWithCallFooWithDifferentSignature.
    self assert: (caller callFoo: changingObject) = 'different signature'
        message: 'changing class should override callFoo method after reloading'.

    "Created: / 06-12-2012 / 21:50:53 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

testModifyingMethod
    "changing class is a subclass of a class implementing callFoo. During the test callFoo method is overridden in changing class."
    
    | caller  changingObject |
    caller := self callerClass new.
    changingObject := self changingClassWithAddedCallFooMethod new.
    self assert: (caller callFoo: changingObject) == 2
        message: 'initial changing class should not override callFoo method'.
    JavaClassReloader reload: self changingClass
        with: self changingClassWithModifiedCallFooMethod.
    self assert: (caller callFoo: changingObject) == 3
        message: 'changing class should override callFoo method after reloading'.

    "Created: / 06-12-2012 / 21:51:14 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!SingleClassReloadingTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id::                                                                                                                        $'
! !
